<?php
// Author: Wesley Stessens
// License: MIT

require_once('simplepie_1.3.1.mini.php');
require_once('Html2Text.php'); // https://github.com/soundasleep/html2text
require_once('Html2TextException.php');

$limitSnippet = 170;

$url = $_REQUEST["url"];

$feed = new SimplePie();
$feed->handle_content_type('application/json');
$feed->set_feed_url($url);
$valid = $feed->init();

$feedJson = array(
  "rssTitle" => $feed->get_title(),
  "rssUrl" => $feed->subscribe_url(),
  "rssSiteUrl" => $feed->get_base(),
  "entries" => array(),
);
foreach ($feed->get_items() as $item) {
  $snippet = $item->get_description(true);
  $content = $item->get_content(true);
  if ($snippet && !$content) {
    $content = $snippet;
    $snippet = Html2Text\Html2Text::convert($snippet);
  } else if (!$snippet && $content) {
    $snippet = Html2Text\Html2Text::convert($content);
  }
  if (strlen($snippet) > $limitSnippet) {
    $snippet = substr($snippet, 0, $limitSnippet) . "...";
  }
  $entry = array(
    "title" => $item->get_title(),
    "contentSnippet" => $snippet,
    "content" => $content,
  );
  $feedJson["entries"][] = $entry;
}

echo json_encode(array(
  "valid" => $valid,
  "responseData" => array(
    "feed" => $feedJson,
  ),
));
?>
